function [ Ps, Pr, flag ] = one_df_link_proximal(hsd, hrd, hsr, theta, lambda, beta, c, Psk, Prk)

lambda_c = lambda - c*Psk;
beta_c = beta - c*Prk;
lambda_beta = hrd*lambda + (hsr-hsd)*beta;
    
if (hsr<=hsd) % hsr>hsd
    flag = 1;
    Ps = 0;
    Pr = 0;
else
    x = 1/lambda/log(2) + lambda_c/c/theta - 1/2/hsr;
    Ps = max(theta/2*(1/lambda/log(2) - 1/hsr + ...
                      sqrt(x*x+1/lambda/hsr/log(2)+Psk/lambda/theta/log(2)*2-1/lambda^2/log(2)/log(2)) - x), ...
             0);
    Pr = -beta_c/c;
    if ((beta_c<0)&&((hsr-hsd)*Ps<=hrd*Pr))
        flag = 2;
    else
        x = 1/lambda/log(2) + lambda_c/c/theta - 1/2/hsd;
        Ps = max(theta/2*(1/lambda/log(2) - 1/hsd + ...
                          sqrt(x*x+1/lambda/hsd/log(2)+Psk/lambda/theta/log(2)*2-1/lambda^2/log(2)/log(2)) - x), ...
                 0);
        Pr = 0;
        if ((lambda_c+c*Ps)/hsd<(beta_c+c*Pr)/hrd)
            flag = 3;
        else
%             a = hrd/hsd;
%             b = hrd*lambda/hsd/c - beta/c - hrd*Psk/hsd + Prk;
%             h1 = theta*hsd/log(2)/(theta+2*b*hrd);
%             h2 = 2*(hsd+a*hrd)/(theta+2*b*hrd);
%             a1 = lambda - c*Psk;
%             delta = (c-a1*h2)^2 + 4*c*h1*h2;
%             Ps = max((-c-a1*h2+sqrt(delta))/2/c/h2, 0);
            Ps = 1/4*(2*c*log(2)*Psk*hsd^2-c*log(2)*theta*hsd+4*c*log(2)*hrd^2*Psk-2*c*log(2)*hrd*Prk*hsd-2*lambda*log(2)*hsd^2-4*log(2)*hrd^2*lambda+2*log(2)*hrd*beta*hsd+hsd*(log(2)*(4*c^2*log(2)*Psk^2*hsd^2+c^2*log(2)*theta^2+4*log(2)*hrd^2*beta^2+8*hsd^2*theta*c+4*lambda^2*log(2)*hsd^2+4*c^2*log(2)*Psk*theta*hsd+8*c^2*log(2)*Psk*hrd*Prk*hsd-8*c*log(2)*Psk*hsd^2*lambda-8*c*log(2)*Psk*hrd*beta*hsd+4*c^2*log(2)*theta*hrd*Prk-4*lambda*log(2)*theta*hsd*c-4*c*log(2)*theta*hrd*beta+4*c^2*log(2)*hrd^2*Prk^2-8*lambda*log(2)*hrd*Prk*hsd*c-8*c*log(2)*hrd^2*Prk*beta+8*lambda*log(2)*hrd*beta*hsd+8*hrd^2*theta*c))^(1/2))/log(2)/(hsd^2+hrd^2)/c;
            Pr = hrd/hsd*Ps + hrd*lambda/hsd/c - hrd*Psk/hsd + Prk - beta/c;
            if (((hsr-hsd)*Ps>=hrd*Pr)&&(Pr>=0))
                flag = 4;
            else
                x = hrd/lambda_beta/log(2) + (hrd*lambda_c+(hsr-hsd)*beta_c)/c/(hrd+(hsr-hsd)^2/hrd)/theta - 1/2/hsr;
                Ps = max(theta/2*(hrd/lambda_beta/log(2) - 1/hsr + ...
                                  sqrt(x*x+hrd/lambda_beta/hsr/log(2)+2*(hrd*Psk+(hsr-hsd)*Prk)/lambda_beta/theta/(1+(hsr-hsd)^2/hrd^2)/log(2)-hrd^2/lambda_beta^2/log(2)/log(2)) - x), ...
                         0);
                Pr = (hsr-hsd)/hrd*Ps;
                tau = (hrd*(lambda_c+c*Ps)-hsd*(beta_c+c*Pr))/(hrd*(lambda_c+c*Ps)+(hsr-hsd)*(beta_c+c*Pr));
                if ((0<=tau)&&(tau<=1))
                    flag = 5;
                else
                    Ps = 0;
                    Pr = 0;
                    flag = 6;
                end
            end
        end
    end
end